#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <math.h>
#include <dshow.h>
#include <qedit.h>
#include "resource.h"

#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"strmiids.lib")

#define MYWNDTITLE		"AviMaker"
#define MYWNDCLASS		"CLASS_AviMaker"
#define WIDTH			320 			// ʂ̏TCYij
#define HEIGHT			260 			// ʂ̏TCYicj
#define MAX_VENC		64				// 񋓂rfIRvbT̍ő吔
#define MAX_LEN			64				// th̍ő啶
#define RELEASE(p)		if (p){p->Release();p=NULL;}

HWND			g_hWnd = NULL;
IVideoWindow	*g_pVW = NULL;
IBaseFilter		*g_pVEnc[MAX_VENC];
char			g_venc_name[MAX_VENC][MAX_LEN];	// rfIRvbT̃th
UINT			g_ct = 17;		// imgtH_DIBV[PX̐
UINT			g_venc_ct = 0;	// 񋓂ꂽrfIRvbT̐
UINT			g_venc_idx = 0;	// IꂽrfIRvbT̔ԍ
double			g_m = 3;		// 摜P̕\ԁibj

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL	CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL	CALLBACK ProcDlg2(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
bool	Init_TimeLine(bool bSave);
bool	Run_FilterGraphTL(bool bSave, IAMTimeline *pTL);
bool	RenderTL(IGraphBuilder *pGB);
bool	SaveTL(IGraphBuilder *pGB, IAMTimeline *pTL, IRenderEngine *pRE);
bool	Enum_Filters(REFCLSID clsid);
void	Cleanup();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	HMENU hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				hMenu,
				hInst,
				NULL);
	
	if(hWnd == NULL)
		return 0;
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		g_hWnd = hWnd;
		if(FAILED(CoInitialize(NULL))){
			MessageBox(hWnd,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		InitCommonControls();
		// rfIRvbT̗
		if(!Enum_Filters(CLSID_VideoCompressorCategory)){
			MessageBox(hWnd,"rfIRvbT񋓂ł܂",MYWNDTITLE,MB_OK);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		break;
		
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_RUN:	// \
			Init_TimeLine(0);
			break;
		case IDM_SAVE:	// ۑ
			BOOL flag;
			flag = DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG2), hWnd, ProcDlg2);
			if(flag){
				if(!Init_TimeLine(1)){
					Cleanup();
				}
			}
			break;
		case IDM_SET:	// ݒ
			DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG1), hWnd, ProcDlg1);
			break;
		case IDM_EXIT:	// I
			SendMessage(hWnd,WM_CLOSE,0,0);
			break;
		}
		break;
		
	case WM_CLOSE:
		int i;
		for(i=0;i<MAX_VENC;i++){
			RELEASE(g_pVEnc[i]);
		}
		Cleanup();
		DestroyWindow(hWnd);
		CoUninitialize();
		PostQuitMessage(0);
		break;
		
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// ProcWnd

// ݒ_CAOvV[W
BOOL CALLBACK ProcDlg1(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		char	s[256];
		itoa(g_ct, s, 10);
		SendDlgItemMessage(hDlg,IDC_EDIT1,WM_SETTEXT,0,(LPARAM) s);
		sprintf(s,"%g",g_m);
		SendDlgItemMessage(hDlg,IDC_EDIT2,WM_SETTEXT,0,(LPARAM) s);
		SendDlgItemMessage(hDlg,IDC_SPIN1,UDM_SETRANGE,0,MAKELONG(0,1024));
		break;
		
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			char s[256];
			SendDlgItemMessage(hDlg,IDC_EDIT1,WM_GETTEXT,sizeof(s),(LPARAM) s);
			g_ct = abs(atoi(s));
			SendDlgItemMessage(hDlg,IDC_EDIT2,WM_GETTEXT,sizeof(s),(LPARAM) s);
			g_m = fabs(atof(s));
			if(g_m > 100){
				g_m = 100;
			}
			else if(g_m == 0 || g_m < 0.01){
				g_m = 0.01;
			}
			EndDialog (hDlg,TRUE);
			break;
		case IDCANCEL:
			EndDialog (hDlg,FALSE);
			break;
		}
		return FALSE;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg1

// ۑ_CAOvV[W
BOOL CALLBACK ProcDlg2(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG:
		UINT	i;
		for(i=0;i<g_venc_ct;i++){
			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) g_venc_name[i]);
		}
		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,g_venc_idx,0);
		break;
		
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDOK:
			g_venc_idx = SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
			EndDialog (hDlg,TRUE);
			break;
		case IDCANCEL:
			EndDialog (hDlg,FALSE);
			break;
		}
		return FALSE;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg2

// ^CC̏
// flag: 0  \, 1  ۑ
bool Init_TimeLine(bool bSave)
{
	HRESULT		hr;
	IAMTimeline	*pTL  = NULL;
	// ^CC쐬
	hr = CoCreateInstance(CLSID_AMTimeline, NULL, CLSCTX_INPROC_SERVER, 
							IID_IAMTimeline, (void**)&pTL);
	if(FAILED(hr)){
		return FALSE;
	}
	// O[v쐬āA^CCɒǉ
	IAMTimelineGroup	*pGp    = NULL;
	IAMTimelineObj		*pGpObj = NULL;
	if(FAILED(pTL->CreateEmptyNode(&pGpObj, TIMELINE_MAJOR_TYPE_GROUP))){
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pGpObj->QueryInterface(IID_IAMTimelineGroup, (void **)&pGp))){
		RELEASE(pGpObj);
		RELEASE(pTL);
		return FALSE;
	}
	AM_MEDIA_TYPE mtGp;	
	ZeroMemory(&mtGp, sizeof(AM_MEDIA_TYPE));
	mtGp.majortype = MEDIATYPE_Video;
	if(FAILED(pGp->SetMediaType(&mtGp))){
		RELEASE(pGp);
		RELEASE(pGpObj);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pTL->AddGroup(pGpObj))){
		RELEASE(pGp);
		RELEASE(pGpObj);
		RELEASE(pTL);
		return FALSE;
	}
	RELEASE(pGpObj);
	// gbN쐬āAO[vɒǉ
	IAMTimelineObj		*pTkObj = NULL;
	IAMTimelineTrack	*pTk = NULL;
	IAMTimelineComp 	*pCp = NULL;
	if(FAILED(pTL->CreateEmptyNode(&pTkObj, TIMELINE_MAJOR_TYPE_TRACK))){
		RELEASE(pGp);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pGp->QueryInterface(IID_IAMTimelineComp, (void **)&pCp))){
		RELEASE(pTkObj);
		RELEASE(pGp);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pCp->VTrackInsBefore(pTkObj, 0))){
		RELEASE(pCp);
		RELEASE(pTkObj);
		RELEASE(pGp);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pTkObj->QueryInterface(IID_IAMTimelineTrack, (void **)&pTk))){
		RELEASE(pCp);
		RELEASE(pTkObj);
		RELEASE(pGp);
		RELEASE(pTL);
		return FALSE;
	}
	RELEASE(pCp);
	RELEASE(pTkObj);
	RELEASE(pGp);
	// \[X쐬āAgbNɒǉ
	IAMTimelineSrc	*pSrc = NULL;
	IAMTimelineObj	*pSrcObj = NULL;
	if(FAILED(pTL->CreateEmptyNode(&pSrcObj, TIMELINE_MAJOR_TYPE_SOURCE))){
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pSrcObj->QueryInterface(IID_IAMTimelineSrc, (void **)&pSrc))){
		RELEASE(pSrcObj);
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pSrcObj->SetStartStop(0, (ULONG)(g_m * g_ct * 10000000)))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	// 摜͑SēTCYŃt@ĆA001n܂AԂɂȂ悤ɂB
	// DIBV[PXɎĝ́ABMP,JPG,TGA3ނBGIF̓V[PXȊOł͎gB
	BSTR bstrFile = SysAllocString(OLESTR(".\\img\\img001.jpg"));
	if(FAILED(pSrc->SetMediaName(bstrFile))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	SysFreeString(bstrFile);
	if(g_m == 0){
		g_m = 0.01;
	}
	if(FAILED(pSrc->SetDefaultFPS(1.0 / g_m))){	// 摜̕\Ԋuit[/bj
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	if(FAILED(pTk->SrcAdd(pSrcObj))){
		RELEASE(pSrc);
		RELEASE(pSrcObj);
		RELEASE(pTk);
		RELEASE(pTL);
		return FALSE;
	}
	RELEASE(pSrc);
	RELEASE(pSrcObj);
	RELEASE(pTk);
	// ^CC̕\܂͕ۑ
	Run_FilterGraphTL(bSave, pTL);
	RELEASE(pTL);
	return TRUE;
}// Init_TimeLine

// \܂͕ۑ̎s
// flag: 0  \, 1  ۑ
bool Run_FilterGraphTL(bool bSave, IAMTimeline *pTL)
{
	HRESULT			hr;
	IGraphBuilder	*pGB = NULL;
	IRenderEngine	*pRE = NULL;
	hr = CoCreateInstance(CLSID_RenderEngine, NULL, CLSCTX_INPROC_SERVER,
							IID_IRenderEngine, (void**) &pRE);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pRE->SetTimelineObject(pTL))){
		RELEASE(pRE);
		return FALSE;
	}
	if(FAILED(pRE->ConnectFrontEnd())){
		RELEASE(pRE);
		return FALSE;
	}
	if(FAILED(pRE->GetFilterGraph(&pGB))){
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	// Đ܂͕ۑ̐ݒ
	if(!bSave){
		if(FAILED(pRE->RenderOutputPins())){
			RELEASE(pGB);
			RELEASE(pRE);
			return FALSE;
		}
		if(!RenderTL(pGB)){
			RELEASE(pGB);
			RELEASE(pRE);
			return FALSE;
		}
	}
	else{
		if(!SaveTL(pGB, pTL, pRE)){
			MessageBox(g_hWnd, "ۑł܂",MYWNDTITLE,MB_ICONWARNING);
			RELEASE(pGB);
			RELEASE(pRE);
			return FALSE;
		}
	}
	// s
	IMediaControl	*pMC  = NULL;
	if(FAILED(pGB->QueryInterface(IID_IMediaControl, (void **)&pMC))){
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	IMediaEvent		*pME  = NULL;
	if(FAILED(pGB->QueryInterface(IID_IMediaEvent, (void **)&pME))){
		RELEASE(pMC);
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	if(FAILED(pMC->Run())){
		RELEASE(pME);
		RELEASE(pMC);
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	if(!bSave)
		SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)"Đ EEE");
	else
		SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)"ۑ EEE");
	// I܂őҋ@
	SetCursor(LoadCursor(NULL,IDC_WAIT));
	long	evCode;
	if(FAILED(pME->WaitForCompletion(INFINITE, &evCode))){
		SetCursor(NULL);
		RELEASE(pME);
		RELEASE(pMC);
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	SetCursor(NULL);
	SendMessage(g_hWnd,WM_SETTEXT,0,(LPARAM)MYWNDTITLE);
	// ~
	if(FAILED(pMC->Stop())){
		RELEASE(pME);
		RELEASE(pMC);
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	// ㏈
	if(FAILED(pRE->ScrapIt())){
		RELEASE(pME);
		RELEASE(pMC);
		RELEASE(pGB);
		RELEASE(pRE);
		return FALSE;
	}
	Cleanup();
	RELEASE(pME);
	RELEASE(pMC);
	RELEASE(pGB);
	RELEASE(pRE);
	return TRUE;
}// Run_FilterGraphTL

// \̐ݒ
bool RenderTL(IGraphBuilder *pGB)
{
	Cleanup();
	if(FAILED(pGB->QueryInterface(IID_IVideoWindow, (void **)&g_pVW))){
		return FALSE;
	}
	if(FAILED(g_pVW->put_Owner((OAHWND)g_hWnd))){
		RELEASE(g_pVW);
		return FALSE;
	}
	if(FAILED(g_pVW->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS))){
		RELEASE(g_pVW);
		return FALSE;
	}
	long		v_wdh,v_hgt;
	IBasicVideo	*pBV;
	if(FAILED(pGB->QueryInterface(IID_IBasicVideo, (void**)&pBV))){
		RELEASE(g_pVW);
		return FALSE;
	}
	pBV->GetVideoSize(&v_wdh, &v_hgt);
	RELEASE(pBV);
	RECT	rc;
	int		edge_wdh,edge_hgt,border_wdh,border_hgt,menu_hgt,title_hgt;
	GetWindowRect(g_hWnd, &rc);
	edge_wdh   = GetSystemMetrics(SM_CXEDGE);
	edge_hgt   = GetSystemMetrics(SM_CYEDGE);
	border_wdh = GetSystemMetrics(SM_CXBORDER);
	border_hgt = GetSystemMetrics(SM_CYBORDER);
	title_hgt  = GetSystemMetrics(SM_CYCAPTION);
	menu_hgt   = GetSystemMetrics(SM_CYMENU);
	MoveWindow(g_hWnd, rc.left, rc.top, v_wdh+edge_wdh*4+border_wdh*2,
				v_hgt+edge_hgt*4+border_hgt*2+title_hgt+menu_hgt, TRUE);
	g_pVW->SetWindowPosition(0, 0, v_wdh, v_hgt);
	return TRUE;
}// RenderTL

// AVIt@Cɕۑݒ
bool SaveTL(IGraphBuilder *pGB, IAMTimeline *pTL, IRenderEngine *pRE)
{
	HRESULT	hr;
	ICaptureGraphBuilder2	*pCGB = NULL;
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&pCGB);
	if(FAILED(hr)){
		return FALSE;
	}
	if(FAILED(pCGB->SetFiltergraph(pGB))){
		RELEASE(pCGB);
		return FALSE;
	}
	if(g_pVEnc[g_venc_idx]){
		if(FAILED(pGB->AddFilter(g_pVEnc[g_venc_idx], L"Video Compressor"))){
			RELEASE(pCGB);
			return FALSE;
		}
	}
	IBaseFilter	*pMux = NULL;
	hr = pCGB->SetOutputFileName(&MEDIASUBTYPE_Avi, L"Sample.avi", &pMux, NULL);
	if(FAILED(hr)){
		RELEASE(pCGB);
		return FALSE;
	}
	long NumGroups;
	pTL->GetGroupCount(&NumGroups);
	for (int i=0;i<NumGroups;i++){
		IPin *pPin;
		if(pRE->GetGroupOutputPin(i, &pPin) == S_OK){
			hr = pCGB->RenderStream(NULL, NULL, pPin, g_pVEnc[g_venc_idx], pMux);
			RELEASE(pPin);
			if(FAILED(hr)){
				RELEASE(pMux);
				RELEASE(pCGB);
				return FALSE;
			}
		}
	}
	Cleanup();
	RELEASE(pMux);
	RELEASE(pCGB);
	return TRUE;
}// SaveTL

// w肳ꂽJeS̃tB^tB^Otɒǉ
// clsid  :[IN]  tB^񋓂JeSCLSID
bool Enum_Filters(REFCLSID clsid)
{
	HRESULT			hr;
	ICreateDevEnum	*pEnum = NULL;
	IEnumMoniker	*pEm = NULL;
	IMoniker		*pM = NULL;
	ULONG			cFetched;
	char			buf[MAX_LEN];
	
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(clsid, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	for(int i=0;i<MAX_VENC;i++){
		RELEASE(g_pVEnc[i]);
	}
	g_pVEnc[0] = NULL;
	strcpy(g_venc_name[0], "none");
	g_venc_ct = 1;
	pEm->Reset();
	while(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				if(strcmp(buf, "")){
					if(SUCCEEDED(pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_pVEnc[g_venc_ct]))){
						if(!strncmp(buf, "Indeo", 5)){
							g_venc_idx = g_venc_ct;
						}
						strncpy(g_venc_name[g_venc_ct], buf, MAX_LEN);
						g_venc_ct ++;
						if(g_venc_ct >= MAX_VENC){
							break;
						}
					}
				}
				SysFreeString(var.bstrVal);
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	if(!g_venc_ct){
		return FALSE;
	}
	return TRUE;
}// Enum_Filters

void Cleanup()
{
	if(g_pVW){
		g_pVW->put_Visible(OAFALSE);
		g_pVW->put_Owner(NULL);
	}
	RELEASE(g_pVW);
}// Cleanup
